from collections import defaultdict
from collections import Counter
import json
import os
import numpy as np
from tqdm import tqdm
# import pandas as pd
def extract_path(data, keep_sent_order):
    # data = data[0]
    sents = data["sents"]

    sentence_id_sum=[]
    for i in range(len(data['vertexSet'])):
        sentence_id = [s['sent_id'] for s in data['vertexSet'][i]]
        sentence_id_sum.append(sentence_id)


    e2e_nodes = [[] for _ in range(len(data['sents']))]
    mention_nodes = [[] for _ in range(len(data['sents']))]
    
    m_sent = {}
    # e2e_sent = defaultdict(dict)
    m2m_sent = defaultdict(dict)
    
    e2m = defaultdict(list)

    m2e_sent = defaultdict(list)
    m2e = {}
    mention_num = -1
    e2sent = defaultdict(list)
 
    sent_list = set()
    for i in range(len(data['vertexSet'])):
        e2m[i] = []
        if i not in e2sent:
            e2sent[i] = []
        s_id = [s['sent_id'] for s in data['vertexSet'][i]]
        e2sent[i].append(s_id)
        for s in s_id:
            sent_list.add(s)
        # sent_list.add(data['vertexSet'][i]['sent_id'])
        for j in range(len(data['vertexSet'][i])):

            mention_num += 1
            e2m[i].append(mention_num)
            m_sent[mention_num] = data['vertexSet'][i][j]['sent_id']
            m2e[mention_num] = i
            for key, value in e2m.items():
                for id in range(len(value)):
                    m2e_sent[value[id]] = {}
                    m2e_sent[value[id]][key] = (data['vertexSet'][key][id]['sent_id'])


    doc_s2s = []
    for i in range(len(sent_list) - 1):
        doc_s2s.append((list(sent_list)[i], list(sent_list)[i + 1]))

    for ns_no, ns in enumerate(data['vertexSet']):
        for n in ns:
            sent_id = int(n['sent_id'])
            # e2e_nodes[sent_id].append(ns_no+1)
            e2e_nodes[sent_id].append(ns_no)

    for m in m2e_sent:
        for e_key, s_valus in m2e_sent[m].items():
            sent_id = int(s_valus)
            mention_nodes[sent_id].append(m)

    for sent_id in range(len(data["sents"])):
        for n1 in mention_nodes[sent_id]:
            for n2 in mention_nodes[sent_id]:
                if n1 == n2:
                    continue
                if n2 not in m2m_sent[n1]:
                    m2m_sent[n1][n2] = set()
                
                m2m_sent[n1][n2].add(sent_id)


    s2s = {}
    # v_list = []


    no_hop_list = []
    for n1 in e2sent:
        if len(e2sent[n1][0]) <= 1:
            continue

        for s in range(len(e2sent[n1][0]) - 1):

            if abs(list(sent_list).index(e2sent[n1][0][s]) - list(sent_list).index(e2sent[n1][0][s + 1])) != 1:
                continue
            if n1 not in s2s:
                s2s[n1] = []
            s2s[n1].append((e2sent[n1][0][s], e2sent[n1][0][s + 1]))
    v_list = []
    for k, v in s2s.items():
        v_list.append(v[0])
    for i in doc_s2s:
        if i in v_list:
            continue
        no_hop_list.append(i)


    one_sentence = defaultdict(dict)
    adjacent_sentence = defaultdict(dict)
    # one_hop = defaultdict(dict)
    for n1 in e2m:
        for n2 in e2m:
            if n1 == n2:
                continue
            for m1 in e2m[n1]:
                for m2 in e2m[n2]:
                    gap = abs(m2e_sent[m1][n1] - m2e_sent[m2][n2])
                   
                    if gap == 0:
                        if m2 not in one_sentence[m1]:
                            one_sentence[m1][m2] = []
                            one_sentence[m2][m1] = []
                        one_sentence[m1][m2].append([m_sent[m1]])
                        one_sentence[m2][m1].append([m_sent[m1]])

                    if gap == 1:
                        if m2e_sent[m1][n1] < m2e_sent[m2][n2]:
                            beg, end = m2e_sent[m1][n1], m2e_sent[m2][n2]
                        else:
                            beg, end = m2e_sent[m2][n2], m2e_sent[m1][n1]
   
                        if (beg, end) in no_hop_list:
                            if m2 not in adjacent_sentence[m1]:
                                adjacent_sentence[m1][m2] = []
                                adjacent_sentence[m2][m1] = []
                            cand_sents = [beg, end]
                            cand_sents.sort()
                            adjacent_sentence[m1][m2].append([cand_sents])
                            adjacent_sentence[m2][m1].append([cand_sents])



    one_hop = defaultdict(dict)

    for n1 in e2m:
        for n2 in e2m:
            if n1 == n2:
                continue
            for m1 in e2m[n1]:
                for m2 in e2m[n2]:
                    for m3 in e2m[n2]:
                        if m2 == m3:
                            continue
                        # 1同2 ,3
                        if m2 in one_sentence[m1]:
                            if m2e_sent[m2][n2] == m2e_sent[m3][n2] or m2e_sent[m1][n1] == m2e_sent[m3][n2]:
                                continue
                            if m3 not in one_hop[m1]:
                                one_hop[m1][m3] = []
                                # one_hop[m3][m1] = []
                            cand_sents = [m2e_sent[m1][n1], m2e_sent[m3][n2]]
                            if keep_sent_order == True:
                                cand_sents.sort()
                            one_hop[m1][m3].append((cand_sents, (m2)))
                            # one_hop[m3][m1].append((cand_sents, (m2)))
                  
                        if m2 in adjacent_sentence[m1]:
                            if m2e_sent[m2][n2] == m2e_sent[m3][n2] or m2e_sent[m1][n1] == m2e_sent[m3][n2]:
                                continue
                            if m3 not in one_hop[m1]:
                                one_hop[m1][m3] = []
                                # one_hop_one[m3][m1] = []
                            cand_sents = [m2e_sent[m1][n1], m2e_sent[m2][n2], m2e_sent[m3][n2]]
                            if keep_sent_order == True:
                                cand_sents.sort()
                            one_hop[m1][m3].append((cand_sents, (m2)))
                 
                        if m1 in one_sentence[m2]:
                            if m2e_sent[m2][n2] == m2e_sent[m3][n2] or m2e_sent[m1][n1] == m2e_sent[m3][n2]:
                                continue
                            if m1 not in one_hop[m3]:
                                one_hop[m3][m1] = []
                                # one_hop[m3][m1] = []
                            cand_sents = [m2e_sent[m1][n1], m2e_sent[m3][n2]]
                            if keep_sent_order == True:
                                cand_sents.sort()
                            one_hop[m3][m1].append((cand_sents, (m2)))
                            # one_hop[m3][m1].append((cand_sents, (m2)))
                       
                        if m1 in adjacent_sentence[m2]:
                            if m2e_sent[m2][n2] == m2e_sent[m3][n2] or m2e_sent[m1][n1] == m2e_sent[m3][n2]:
                                continue
                            if m1 not in one_hop[m3]:
                                one_hop[m3][m1] = []
                                # one_hop[m3][m1] = []
                            cand_sents = [m2e_sent[m1][n1], m2e_sent[m2][n2], m2e_sent[m3][n2]]
                            if keep_sent_order == True:
                                cand_sents.sort()
                            one_hop[m3][m1].append((cand_sents, (m2)))

                        for m4 in e2m[n1]:
                            if m1 == m4:
                                continue
                            if m2 in one_sentence[m4]:
                                if m2e_sent[m2][n2] == m2e_sent[m3][n2] or m2e_sent[m1][n1] == m2e_sent[m4][n1] or \
                                        m2e_sent[m2][n2] == m2e_sent[m1][n1] or m2e_sent[m1][n1] == m2e_sent[m3][
                                    n2] or m2e_sent[m4][n1] == m2e_sent[m3][n2]:
                                    continue
                                if m3 not in one_hop[m1]:
                                    one_hop[m1][m3] = []
                                    # one_hop[m3][m1] = []
                                cand_sents = [m2e_sent[m1][n1], m2e_sent[m4][n1], m2e_sent[m3][n2]]
                                if keep_sent_order == True:
                                    cand_sents.sort()
                                one_hop[m1][m3].append((cand_sents, (m2)))
                            if m2 in adjacent_sentence[m4]:
                                if m2e_sent[m2][n2] == m2e_sent[m3][n2] or m2e_sent[m1][n1] == m2e_sent[m4][n1] or \
                                        m2e_sent[m2][n2] == m2e_sent[m1][n1] or m2e_sent[m1][n1] == m2e_sent[m3][
                                    n2] or m2e_sent[m4][n1] == m2e_sent[m3][n2]:
                                    continue
                                if m3 not in one_hop[m1]:
                                    one_hop[m1][m3] = []
                                    # one_hop[m3][m1] = []
                                cand_sents = [m2e_sent[m1][n1], m2e_sent[m4][n1], m2e_sent[m2][n2],
                                              m2e_sent[m3][n2]]
                                if keep_sent_order == True:
                                    cand_sents.sort()
                                one_hop[m1][m3].append((cand_sents, (m2)))
                            # one_hop_one[m3][m1].append((cand_sents, (m2)))


    # mention_path_two = defaultdict(dict)
    two_hop = defaultdict(dict)

    # entityNum = len(data['vertexSet'])
    for n1 in e2m:
        for n2 in e2m:
            if n1 == n2:
                continue
            for n3 in e2m:
                if n3 == n1 or n3 == n2:
                    continue
                for m1 in e2m[n1]:
                    for m2 in e2m[n2]:
                        for m3 in e2m[n3]:

                            if m3 in one_hop[m1] and (
                                    m2 in adjacent_sentence[m3] or m2 in one_hop[m3] or m2 in one_sentence[m3]):
                                # for s1 in m2m_sent[m1][m3]:
                                # for s2 in m2m_sent[m3][m2]:
                                if m2e_sent[m1][n1] == m2e_sent[m2][n2]:
                                    continue
                                if m2 not in two_hop[m1]:
                                    two_hop[m1][m2] = []
                                cand_sents = [m2e_sent[m1][n1], m2e_sent[m3][n3], m2e_sent[m2][n2]]
                                if keep_sent_order == True:
                                    cand_sents.sort()
                                two_hop[m1][m2].append((cand_sents, (m3)))

    # 3-hop Path
    three_hop = defaultdict(dict)

    for n1 in e2m:
        for n2 in e2m:
            if n1 == n2:
                continue
            for n3 in e2m:
                if n3 == n1 or n3 == n2:
                    continue
                for n4 in e2m:
                    if n4 == n1 or n4 == n2 or n4 == n3:
                        continue
                    for m1 in e2m[n1]:
                        for m2 in e2m[n2]:
                            for m3 in e2m[n3]:
                                for m4 in e2m[n4]:
                                    # if m3 == m4:
                                    #     continue
                       
                                    if m3 in two_hop[m1] and (
                                            m2 in adjacent_sentence[m3] or m2 in one_hop[m3] or m2 in one_sentence[m3]):
                                        if m2e_sent[m1][n1] == m2e_sent[m2][n2]:
                                            continue
                                        if m2 not in three_hop[m1]:
                                            three_hop[m1][m2] = []
                                        cand_sents = [m2e_sent[m1][n1], m2e_sent[m3][n3], m2e_sent[m2][n2]]
                                        if keep_sent_order == True:
                                            cand_sents.sort()
                                        three_hop[m1][m2].append((cand_sents, (m3)))
                                    if (m3 in adjacent_sentence[m1] or m3 in one_hop[m1] or m3 in one_sentence[
                                        m1]) and m2 in two_hop[m3]:
                                        if m2e_sent[m1][n1] == m2e_sent[m2][n2]:
                                            continue
                                        if m2 not in three_hop[m1]:
                                            three_hop[m1][m2] = []
                                        cand_sents = [m2e_sent[m1][n1], m2e_sent[m3][n3], m2e_sent[m2][n2]]
                                        if keep_sent_order == True:
                                            cand_sents.sort()
                                        three_hop[m1][m2].append((cand_sents, (m3)))

                                    if (m3 in adjacent_sentence[m1] or m3 in one_hop[m1] or m3 in one_sentence[
                                        m1]) and (
                                            m4 in adjacent_sentence[m3] or m4 in one_hop[m3] or m4 in one_sentence[
                                        m3]) and (
                                            m2 in adjacent_sentence[m4] or m2 in one_hop[m4] or m2 in one_sentence[m4]):
                                        if m2e_sent[m1][n1] == m2e_sent[m2][n2]:
                                            continue
                                        if m2 not in three_hop[m1]:
                                            three_hop[m1][m2] = []
                                        cand_sents = [m2e_sent[m1][n1], m2e_sent[m3][n3], m2e_sent[m4][n4],
                                                      m2e_sent[m2][n2]]
                                        if keep_sent_order == True:
                                            cand_sents.sort()
                                        three_hop[m1][m2].append((cand_sents, (m3)))

    other = defaultdict(dict)
    # Merge
    merge = defaultdict(dict)
    for n1 in e2m:
        for n2 in e2m:
            if n1 == n2:
                continue
            for m1 in e2m[n1]:
                for m2 in e2m[n2]:
                    if m2 in one_sentence[m1]:
                        if m2 in merge[m1]:
                            merge[m1][m2] += one_sentence[m1][m2]
                        else:
                            merge[m1][m2] = one_sentence[m1][m2]
                    if m2 in adjacent_sentence[m1]:
                        if m2 in merge[m1]:
                            merge[m1][m2] += adjacent_sentence[m1][m2]
                        else:
                            merge[m1][m2] = adjacent_sentence[m1][m2]
                    if m2 in two_hop[m1]:
                        if m2 in merge[m1]:
                            merge[m1][m2] += two_hop[m1][m2]
                        else:
                            merge[m1][m2] = two_hop[m1][m2]

                    if m2 in three_hop[m1]:
                        if m2 in merge[m1]:
                            merge[m1][m2] += three_hop[m1][m2]
                        else:
                            merge[m1][m2] = three_hop[m1][m2]

                    if m2 in one_hop[m1]:
                        if m2 in merge[m1]:
                            merge[m1][m2] += one_hop[m1][m2]
                        else:
                            merge[m1][m2] = one_hop[m1][m2]

                    else:
                        sents1 = set()
                        item1=[]
                        if m2 not in other[m1]:
                            other[m1][m2] = []

           
                        flat_list = [num for sublist in sentence_id_sum for num in sublist]
                        collections_words = Counter(flat_list)

           
                        most_counter = collections_words.most_common(2)
                        most_counter3 = collections_words.most_common(3)



                        for item in most_counter3:
                            item1.append(item[0])
                        if 0 in item1:
                            sents1.add(0)

                        else:
                           
                            for item2 in most_counter:
                                sents1.add(item2[0])

                        cand_sents = [i for i in sents1]
                        if keep_sent_order == True:
                            cand_sents.sort()
                            other[m1][m2].append((cand_sents, (m1, m2)))
                        if m2 in other[m1]:
                            if m2 in merge[m1]:
                                merge[m1][m2] += other[m1][m2]
                            else:
                                merge[m1][m2] = other[m1][m2]

    m_merge = defaultdict(dict)
    for h in merge:
        for t in merge[h]:
            if t not in m_merge[h]:
                m_merge[h][t] = []
            m_merge[h][t].append(merge[h][t])
    # print(type(e_merge))

    # print(type(e_merge))
    m_evi = defaultdict(dict)
    for i in m_merge:
        # n = set()
        for j in m_merge[i]:
            n = set()
            # print(m[i][j])
            for k in range(len(m_merge[i][j])):

                # print(m[i][j][k])
                for p in range(len(m_merge[i][j][k])):
                    # print(m[i][j][k][0][0])
                    if isinstance(m_merge[i][j][k][0][0], int):
                        #             if type(m[i][j][k][0][0]) == int:
                        n.add(m_merge[i][j][k][0][0])
                    # for b in m[i][j][k][0][0]:
                    if isinstance(m_merge[i][j][k][0][0], list):
                        for l in m_merge[i][j][k][0][0]:
                            #                 # if len(m[i][j][k][0][0])==1:
                            n.add(l)
            if j not in m_evi[i]:
                m_evi[i][j] = []
            m_evi[i][j].append(list(n))
    #


    mht_evi = defaultdict(dict)
    for h in m_evi:
        for t in m_evi[h]:
            if h+1 not in mht_evi[t+1]:
                mht_evi[h+1][t+1] = []
                mht_evi[h+1][t+1].append(m_evi[h][t][0])
            elif h+1 in mht_evi[t+1] or t+1 in mht_evi[h+1]:
                continue
    mht_evi.pop(len(mht_evi))


    all_evi = defaultdict(dict)
    for h in mht_evi:
        for t in mht_evi[h]:
            if len(mht_evi[h][t][0]) > 1:
                str_evi = ""
                for i in range(len(mht_evi[h][t][0])):
                    str_evi += str(int(mht_evi[h][t][0][i]) + 1)
                str_evi = ','.join([d for d in str_evi if d.isdigit()])
                # if [h,t] not in all_evi[str_evi]:
                if str_evi not in all_evi:
                    all_evi[str_evi] = []
                all_evi[str_evi].append([h, t])
            if len(mht_evi[h][t][0]) == 1 and len(m2e_sent[t]) > 0:
                str_evi = str(int(mht_evi[h][t][0][0]) + 1)
                if len(e2m[list(m2e_sent[h])[0]]) == 1 and len(e2m[list(m2e_sent[t])[0]]) == 1:
                    if str_evi not in all_evi:
                        all_evi[str_evi] = []
                        all_evi[str_evi].append([h, t])



    return all_evi